/* powerd.h.  Generated automatically by configure.  */
#ifndef POWERD_H
#define POWERD_H

/* Define to empty if the keyword does not work.  */
/* #undef const */

/* Define as the return type of signal handlers (int or void).  */
#define RETSIGTYPE void

/* Define if you have the ANSI C header files.  */
#define STDC_HEADERS 1

/* Define if you can safely include both <sys/time.h> and <time.h>.  */
#define TIME_WITH_SYS_TIME 1

/* Define if you have the select function.  */
#define HAVE_SELECT 1

/* Define if you have the socket function.  */
#define HAVE_SOCKET 1

/* Define if you have the strdup function.  */
#define HAVE_STRDUP 1

/* Define if you have the strerror function.  */
#define HAVE_STRERROR 1

/* Define if you have the <fcntl.h> header file.  */
#define HAVE_FCNTL_H 1

/* Define if you have the <sys/ioctl.h> header file.  */
#define HAVE_SYS_IOCTL_H 1

/* Define if you have the <sys/time.h> header file.  */
#define HAVE_SYS_TIME_H 1

/* Define if you have the <syslog.h> header file.  */
#define HAVE_SYSLOG_H 1

/* Define if you have the <unistd.h> header file.  */
#define HAVE_UNISTD_H 1

#include "config.h"

#define MAXBUF		1024

/* Default port */
#define PORT		532

/* This should be left as is... were made to be able to handle an attack, 
 * thats why we can handle so many connections. 
 */
#define MAXCONNECTIONS	1010

#define TIMEOUT		20

#define VERSION		"2.0.2"

/*********** End users dont need to modify anything below this **********/
/***********           If you do, Please send patches.         **********/
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <signal.h>
#include <unistd.h>
#include <fcntl.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <errno.h>
#include <syslog.h>
#include <unistd.h>
#include <pwd.h>
#include <time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/time.h>
#include <netdb.h>
#include <libgen.h>
#include <paths.h>
#ifndef _PATH_VARRUN
# define  _PATH_VARRUN	"/var/run/"
#endif

#define CONNECTED	0x01
#define SENTNOTICE	0x02
#define VALIDHOST	0x04
#define AUTHENTICATED	0x08
#define SENTCOMMAND	0x10
#define WEAGREE		0x20

#define QUIT            1
#define SHUTDOWN        2
#define CANCEL          3

#define FAIL 1
#define OK 0

#define addstatus(x,y) ((((x)->status) |= (y)))
#define delstatus(x,y) ((x)->status &= ~(y))
#define checkstatus(x,y) ((((x)->status) & (y)))

typedef struct client_ Client;
struct client_ {
    char *host;
    int port;
    char *password;
    Client *next;
};

typedef struct listen_ Listen;
struct listen_ {
    char *host;
    char *password;
    Listen *next;
};

typedef struct filedescriptor_ FileDescriptor;
struct filedescriptor_ {
    int fd;
    struct in_addr in;
    unsigned int status;
    time_t time;
    FileDescriptor *next, *prev;
    Client *client;
    Listen *listen;
};

void mylog(int type, int facility, const char *entry, ...);
#define	log(args...)	mylog(args)
uid_t uname2id(char *name);
void notifyinit(int status);
void monitorups(int delay);
void openconfig(int *delay);
FileDescriptor *addfd(int fd, struct in_addr in);
void delfd(FileDescriptor *fd);
void reinstate(void);
int bindport(void);
int parse(FileDescriptor *fd, char *buf);
void addlisten(char *host, char *password);
void addclient(char *host, char *password, int port);
void request(FileDescriptor *fd, char *param, int action);
int vhost(FileDescriptor *fd, char *param);
void auth(FileDescriptor *fd, char *password);
void quit_sig(int sig);
void debughelp(int sig);
/* static */ void alarm_handler(int sig);
int notifyclients(int status);
void getrid(FileDescriptor *fd, int i);
void bsdshutdown(int status);

#ifdef SIGPWR
#define SYSV_SIGNAL
#endif

#ifndef LOG_AUTHPRIV
#define LOG_AUTHPRIV LOG_AUTH
#endif

#endif
